## dshearer-jobber.zip

=== Makefile ===
# GNU-standard vars (cf. http://www.gnu.org/prep/standards/html_node/Makefile-Conventions.html)
SHELL = /bin/sh

# Paths may be loaded from mk/config.mk, whcih is made by configure
-include mk/config.mk
prefix ?= /usr/local
bindir ?= ${prefix}/bin
libexecdir ?= ${prefix}/libexec
sysconfdir ?= /etc
localstatedir ?= ${prefix}/var

srcdir = .
INSTALL = install
INSTALL_PROGRAM = ${INSTALL}

JOBBER_VERSION := $(shell cat ${srcdir}/version)
SRC_TARBALL = jobber-${JOBBER_VERSION}.tgz
SRC_TARBALL_DIR = jobber-${JOBBER_VERSION}

OUTPUT_DIR = bin

GO = go
GO_VERSION = 1.11
# NOTE: '-mod=vendor' prevents go from downloading dependencies
GO_BUILD_BASE_FLAGS := -mod=vendor
COMPILETIME_VARS := \
	-X 'github.com/dshearer/jobber/common.jobberVersion=${JOBBER_VERSION}' \
	-X 'github.com/dshearer/jobber/common.etcDirPath=${sysconfdir}'

GO_BUILD := ${GO} build ${GO_BUILD_BASE_FLAGS} -ldflags "${COMPILETIME_VARS}"
GO_VET = ${GO} vet -mod=vendor
GO_TEST = ${GO} test -mod=vendor
GO_GEN = ${GO_WITH_TOOLS} generate -mod=vendor
GO_CLEAN = ${GO} clean -mod=vendor

PACKAGES = \
	github.com/dshearer/jobber/common \
	github.com/dshearer/jobber/ipc \
	github.com/dshearer/jobber/jobber \
	github.com/dshearer/jobber/jobbermaster \
	github.com/dshearer/jobber/jobberrunner \
	github.com/dshearer/jobber/jobfile

include mk/def-sources.mk

.PHONY : default
default : build

include mk/buildtools.mk # defines 'GO_WITH_TOOLS' and 'GOYACC'

################################################################################
# BUILD
################################################################################

.PHONY : build
build : check ${OUTPUT_DIR}/jobber ${OUTPUT_DIR}/jobbermaster \
		${OUTPUT_DIR}/jobberrunner ${OUTPUT_DIR}/jobber.conf
	@echo
	@echo "Built with these paths:"
	@echo "localstatedir: ${localstatedir}"
	@echo "libexecdir: ${libexecdir}"
	@echo "sysconfdir: ${sysconfdir}"

.PHONY : check
check : ${TEST_SOURCES} jobfile/parse_time_spec.go
	@go version
	@echo GO TEST
	@${GO_TEST} ${PACKAGES}

${OUTPUT_DIR}/% : ${MAIN_SOURCES} jobfile/parse_time_spec.go
	@$(call checkGoVersion)
	@echo GO VET
	@${GO_VET} ${PACKAGES}
	@echo BUILD $*
	@${GO_BUILD} -o "$@" "github.com/dshearer/jobber/$*"

${OUTPUT_DIR}/jobber.conf : ${OUTPUT_DIR}/jobbermaster
	@echo BUILD $@
	@${OUTPUT_DIR}/jobbermaster defprefs --var "${localstatedir}" --libexec "${libexecdir}" > "$@"

jobfile/parse_time_spec.go : ${GOYACC} ${JOBFILE_SOURCES}
	@echo GEN SRC
	@${GO_GEN} -mod=vendor github.com/dshearer/jobber/jobfile

################################################################################
# INSTALL
################################################################################

install : \
	${DESTDIR}${libexecdir}/jobbermaster \
	${DESTDIR}${libexecdir}/jobberrunner \
	${DESTDIR}${bindir}/jobber \
	${DESTDIR}${sysconfdir}/jobber.conf

${DESTDIR}${libexecdir}/% : ${OUTPUT_DIR}/%
	@echo INSTALL $@
	@mkdir -p "${dir $@}"
	@${INSTALL_PROGRAM} "$<" "$@"

${DESTDIR}${bindir}/% : ${OUTPUT_DIR}/%
	@echo INSTALL $@
	@mkdir -p "${dir $@}"
	@${INSTALL_PROGRAM} "$<" "$@"

${DESTDIR}${sysconfdir}/jobber.conf : ${OUTPUT_DIR}/jobber.conf
	@echo INSTALL $@
	@mkdir -p "${dir $@}"
	@cp "$<" "$@"

.PHONY : uninstall
uninstall :
	-rm "${DESTDIR}${libexecdir}/jobbermaster"
	-rm "${DESTDIR}${libexecdir}/jobberrunner"
	-rm "${DESTDIR}${bindir}/jobber"
	-rm "${DESTDIR}${sysconfdir}/jobber.conf"

.PHONY : dist
dist :
	mkdir -p "${DESTDIR}dist-tmp"
	"${srcdir}/buildtools/srcsync" ${ALL_SOURCES} \
		"${DESTDIR}dist-tmp/${SRC_TARBALL_DIR}"
	tar -C "${DESTDIR}dist-tmp" -czf "${DESTDIR}${SRC_TARBALL}" \
		"${SRC_TARBALL_DIR}"
	rm -rf "${DESTDIR}dist-tmp"

################################################################################
# CLEAN
################################################################################

.PHONY : clean
clean : clean-buildtools
	@echo CLEAN
	@-${GO_CLEAN} -i ${PACKAGES}
	@rm -rf "${DESTDIR}${SRC_TARBALL}.tgz" jobfile/parse_time_spec.go \
		jobfile/y.output "${OUTPUT_DIR}"

################################################################################
# MISC
################################################################################

define checkGoVersion
${srcdir}/buildtools/versionge "$$(go version | egrep -o '[[:digit:].]+' | head -n 1)" "${GO_VERSION}"
endef

=== packaging/Makefile ===
PLATFORMS = alpine_3.6 centos_7 debian_9

.PHONY : main
main :
	@echo "Choose pkg-vm or test-vm or clean or deepclean"

define RECIPES
.PHONY : pkg-vm-${platform}
pkg-vm-${platform} :
	mkdir -p "results/${platform}"
	$${MAKE} -j 1 -C ${platform} pkg-vm \
		"DESTDIR=$(abspath results/${platform})/" \
	    2>&1 | tee "results/${platform}/pkg-vm.log"

test-vm-${platform} :
	mkdir -p "results/${platform}"
	$${MAKE} -j 1 -C ${platform} test-vm \
		"DESTDIR=$(abspath results/${platform})/" \
	    2>&1 | tee "results/${platform}/test-vm.log"

clean-${platform} :
	$${MAKE} -j 1 -C ${platform} clean

deepclean-${platform} :
	$${MAKE} -j 1 -C ${platform} deepclean

make-vm-${platform} :
	$${MAKE} -j 1 -C ${platform} .vm-is-running
endef

$(foreach platform,${PLATFORMS}, $(eval ${RECIPES}))

.PHONY : pkg-vm
pkg-vm : $(patsubst %,pkg-vm-%,${PLATFORMS})

.PHONY : test-vm
test-vm : $(patsubst %,test-vm-%,${PLATFORMS})

.PHONY : make-vm
make-vm : $(patsubst %,make-vm-%,${PLATFORMS})

.PHONY : clean
clean : $(patsubst %,clean-%,${PLATFORMS})
	rm -rf results

.PHONY : deepclean
deepclean : $(patsubst %,deepclean-%,${PLATFORMS})

=== smoke_tests/Makefile ===
DOCKER_IMAGE_NAME = jobber/smoke_test
PLATFORM = centos_7
SRC_ROOT := $(abspath ..)
VERSION := $(shell cat ${SRC_ROOT}/version)
SRC_TARFILE = jobber.tgz

DOCKER_RUN = docker run ${DOCKER_IMAGE_NAME}

.PHONY : test-docker
test-docker : platform_tests.tar jobber.tgz
	docker build -t "${DOCKER_IMAGE_NAME}" .
	(docker run "${DOCKER_IMAGE_NAME}" ||:) > testlog.txt
	mkdir -p test_report
	docker cp "`docker ps -alq`:/log.html" test_report/
	docker cp "`docker ps -alq`:/report.html" test_report/
	
	@cat testlog.txt
	@egrep '.* critical tests,.* 0 failed[[:space:]]*$$' testlog.txt\
		>/dev/null

platform_tests.tar : $(wildcard ${SRC_ROOT}/platform_tests/**)
	tar -C "${SRC_ROOT}" -cf "$@" platform_tests

jobber.tgz :
	make -C "${SRC_ROOT}" dist "DESTDIR=$(abspath .)/"
	mv jobber-${VERSION}.tgz "$@"

.PHONY : clean
clean :
	rm -rf platform_tests.tar jobber.tgz test_report testlog.txt

=== packaging/alpine/Makefile ===
include ../head.mk

PKGREL := $(shell cat pkgrel)
PLATFORM = x86_64

# Alpine doesn't allow hyphens in version numbers
ALPINE_VERSION = ${shell echo ${VERSION} | sed -e 's/\-/_/' | sed -e 's/pr./rc/'}

# required by tail.mk:
PKGFILE = jobber-${ALPINE_VERSION}-r${PKGREL}.apk
PKGFILE_DEPS = \
	APKBUILD \
	jobber.initd \
	jobber.post-deinstall \
	jobber.post-install \
	jobber.post-upgrade \
	jobber.pre-deinstall \
	pkgrel
PKGFILE_VM_PATH = ${PKGFILE}
PACKAGING_SUBDIR = alpine
INSTALL_PKG_CMD = apk add --allow-untrusted ${PKGFILE}
UNINSTALL_PKG_CMD = apk remove jobber
SRC_TARBALL = jobber.tgz
SRC_TARBALL_DIR = jobber

.PHONY : pkg-local
pkg-local : ${WORK_DIR}/${SRC_TARBALL} ${PKGFILE_DEPS}
	# make package
	cp "${WORK_DIR}/${SRC_TARBALL}" ./
	abuild checksum
	env "pkgrel=${PKGREL}" "pkgver=${ALPINE_VERSION}" abuild -r
	
	# copy package out of VM
	mkdir -p "${DESTDIR}/"
	find "${HOME}/packages/packaging" -name "*.apk" -exec cp {} "${DESTDIR}/" ';'

include ../tail.mk

test-vm :
	@echo "Cannot test on Alpine"

=== packaging/debian/Makefile ===
include ../head.mk

# required by tail.mk:
PKGFILE = jobber_${VERSION}-1_amd64.deb
PKGFILE_DEPS = $(wildcard debian-pkg/**)
PKGFILE_VM_PATH = jobber_${VERSION}-1_amd64.deb
PACKAGING_SUBDIR = debian
INSTALL_PKG_CMD = sudo dpkg -i ${PKGFILE}
UNINSTALL_PKG_CMD = sudo dpkg -r jobber

.PHONY : pkg-local
pkg-local : ${WORK_DIR}/${SRC_TARBALL}
	cp "${WORK_DIR}/${SRC_TARBALL}" \
		"${SRC_ROOT}/../jobber_${VERSION}.orig.tar.gz"
	cp -RL debian-pkg "${SRC_ROOT}/debian"
	rm -rf "${WORK_DIR}"
	cd "${SRC_ROOT}" && dpkg-buildpackage -us -uc
	mkdir -p "${DESTDIR}/"
	mv "${SRC_ROOT}"/../*.deb "${DESTDIR}/"

include ../tail.mk

=== packaging/rpm/Makefile ===
include ../head.mk

PKGREL := $(shell cat pkgrel)
PLATFORM = x86_64

# RPMs don't allow hyphens in version numbers
RPM_VERSION = ${shell echo ${VERSION} | sed -e 's/\-/_/'}

# required by tail.mk:
PKGFILE = jobber-${RPM_VERSION}-${PKGREL}.el7.centos.${PLATFORM}.rpm
PKGFILE_DEPS = jobber.spec
PKGFILE_VM_PATH = jobber-${RPM_VERSION}-${PKGREL}.el7.centos.${PLATFORM}.rpm
PACKAGING_SUBDIR = rpm
INSTALL_PKG_CMD = sudo yum install -y ${PKGFILE} && \
	sudo systemctl start jobber
UNINSTALL_PKG_CMD = sudo systemctl stop jobber; \
	sudo yum remove -y jobber
SRC_TARBALL = jobber-${RPM_VERSION}.tgz
SRC_TARBALL_DIR = jobber-${RPM_VERSION}

.PHONY : pkg-local
pkg-local : jobber.spec ${WORK_DIR}/${SRC_TARBALL}
	# make RPM tree
	mkdir -p "${WORK_DIR}" \
		 "${WORK_DIR}/BUILD" \
                 "${WORK_DIR}/RPMS" \
                 "${WORK_DIR}/RPMS/${PLATFORM}" \
                 "${WORK_DIR}/SOURCES" \
                 "${WORK_DIR}/SPECS" \
                 "${WORK_DIR}/SRPMS"
	cp "$<" "${WORK_DIR}/SPECS"
	
	# copy sources
	cp "${WORK_DIR}/${SRC_TARBALL}" jobber.service \
		"${WORK_DIR}/SOURCES/"
	
	# build RPMs
	yum-builddep --assumeyes "$<"
	cd "${WORK_DIR}/SPECS" && rpmbuild -bb \
		--define "_topdir ${abspath ${WORK_DIR}}" \
		--define "_pkg_version ${RPM_VERSION}" \
		--define "_pkg_release ${PKGREL}" \
		--define "_enable_debug_packages 0" \
		"$<"
	mkdir -p "${DESTDIR}"
	find "${WORK_DIR}/RPMS" -name '*.rpm' | xargs cp -t "${DESTDIR}"

include ../tail.mk

=== packaging/alpine/APKBUILD ===
# Contributor: C. Dylan Shearer <dylan@nekonya.info>
# Maintainer: C. Dylan Shearer <dylan@nekonya.info>
pkgname=jobber
pkgdesc="A replacement for cron, with sophisticated status-reporting and error-handling."
url="https://dshearer.github.io/${pkgname}/"
arch="all"
license="MIT"
depends=""
depends_dev=""
makedepends="$depends_dev openrc go>=1.8 rsync"
install="${pkgname}.post-install ${pkgname}.pre-deinstall ${pkgname}.post-deinstall ${pkgname}.post-upgrade"
source="${pkgname}.initd ${pkgname}.tgz"

_builddir="${startdir}/build"

prepare() {
	"${srcdir}/${pkgname}/configure" --prefix=/usr --localstatedir=/var
}

build() {
	make -C "${srcdir}/${pkgname}" build
}

check() {
    make -C "${srcdir}/${pkgname}" check
}

package() {
    set -e

    # install
	make -C "${srcdir}/${pkgname}" install "DESTDIR=${pkgdir}/"

    # install init script
	local INITD="${pkgdir}/etc/init.d"
	mkdir -p "${INITD}"
	cp "${startdir}/${pkgname}.initd" "${INITD}/jobber"
}

sha512sums="7dacd120effe454daded552623c99bb1b695c6ce47819b7f627772a1f6ca494b5ff83adcae2693e35ef600e92268ef5066a92fc7522043316864edde6f892550  jobber.initd
9831f6dc858fa085c317a496affeb63945de5a96a7656008ef493783bebca65ee3445bbad0dfe646378ae9b75622eef395b43a20be7fa435c5b16247c1324702  jobber.tgz"
